#
# spec file for package openstack-monasca-log-agent
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
# Copyright 2017 Fujitsu LIMITED
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%define mod_name logstash-output-monasca_log_api
%define mod_full_name %{mod_name}-%{version}
%define sname monasca-log-agent
Name:           openstack-%{sname}
Version:        0.5.3
Release:        6.1
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Url:            https://github.com/FujitsuEnablingSoftwareTechnologyGmbH/logstash-output-monasca_api
Source:         https://rubygems.org/gems/%{mod_full_name}.gem 
Source1:        %{name}.logrotate
Source2:        %{sname}.conf.sample
Source3:        %{name}.service
Summary:        Collects logs or events via logstash and send them to monasca-log-api
License:        Apache-2.0
Group:          Monitoring/Tools
Requires:       logrotate
Requires:       logstash >= 2.3.0
Requires(post): logstash
BuildArch:      noarch
%if 0%{?suse_version} >= 1210
BuildRequires:  systemd-rpm-macros
%endif

%description
monasca-log-agent is actually a label for logstash-output-monasca_log_api
and custom configuration file, both of which are used to run
instance of logstash

%prep
# no-op

%build
# no-op

%install

# etc
install -d -m 755 %{buildroot}%{_sysconfdir}/%{sname}/conf.d
install -D -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
install -D -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/%{sname}/agent.conf.sample

# usr
install -d -m 755 %{buildroot}/%{_datadir}/%{sname}

# var
install -d -m 750 %{buildroot}%{_localstatedir}/log/%{sname}

# service file
install -D -m 644 %{SOURCE3} %{buildroot}%{_unitdir}/%{name}.service
mkdir -p %{buildroot}%{_sbindir}
ln -s %{_sbindir}/service %{buildroot}%{_sbindir}/rc%{name}

# gem file
install -D -m 644 %{SOURCE0} %{buildroot}/%{_datadir}/%{sname}/logstash-output-monasca_log_api-0.5.3.gem

%pre
%service_add_pre %{name}.service

%post
%service_add_post %{name}.service
/opt/logstash/bin/logstash-plugin install --local %{_datadir}/%{sname}/logstash-output-monasca_log_api-0.5.3.gem
cat <<EOF

================================================================================
In order to start shipping logs to monasca-log-api you need to copy and edit
%{_sysconfdir}/monasca-log-agent/agent.conf.sample.

1) cp %{_sysconfdir}/monasca-log-agent/agent.conf.sample %{_sysconfdir}/monasca-log-agent/agent.conf
2) vi %{_sysconfdir}/monasca-log-agent/agent.conf

and provide:
1) keystone credentials (and url) identyfying user who wishes to send logs
2) monasca-log-api url
3) global dimensions, that will be attached to every log sent, specifically
describing each and one of them.

================================================================================

EOF

%preun
%service_del_preun %{name}.service

%postun
# uninstalling requires NET access
# /opt/logstash/bin/logstash-plugin uninstall logstash-output-monasca_log_api
%service_del_postun %{name}.service
cat <<EOF

================================================================================
Uninstallation of logstash-output-monasca_log_api is not possible without
internet access, which might not be available due to proxy
limitations or simply because it is absent, therefore uninstalltion
cannot be guaranteed.

You can try removing plugin manually using following command:

/opt/logstash/bin/logstash-plugin uninstall logstash-output-monasca_log_api
================================================================================

EOF

%files

%{_unitdir}/%{name}.service
%{_sbindir}/rc%{name}

%dir %{_sysconfdir}/%{sname}
%dir %{_sysconfdir}/%{sname}/conf.d
%dir %{_datadir}/%{sname}

%config(noreplace) %{_sysconfdir}/%{sname}/agent.conf.sample
%{_datadir}/%{sname}/logstash-output-monasca_log_api-0.5.3.gem

%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%dir %{_localstatedir}/log/%{sname}

%changelog
* Wed Sep 20 2017 dmueller@suse.com
- add post-requires on logstash for the post script
* Thu May 18 2017 jakub.wachowski@ts.fujitsu.com
- Logrotate should be executed as root:root (bsc#1048688, FATE#323204)
* Tue Apr 18 2017 dmueller@suse.com
- systemd: fix reload
* Fri Apr  7 2017 johannes.grassler@suse.com
- Converted service to running as root and removed creation of
  openstack-monasca-log-agent user (agent needs to be root to
  access everything in /var/log)
* Tue Mar 14 2017 johannes.grassler@suse.com
- Renamed package to openstack-monasca-log-agent
* Sun Jan  1 2017 tomasz.trebski@ts.fujitsu.com
- Initial version of the package
